#include <math.h>

void dft(double x[],double y[],double a[], double b[], int n, int sign);

/* x：存放要变换数据的实部
 * y：存放要变换数据的虚部
 * a：存放变换结果的实部
 * b：存放变换结果的虚部
 * n：数据长度
 * sign：定义正变换和反变换的标志；sign=1，正变换；sign=-1，反变换；
 */


void dft(double x[],double y[],double a[], double b[], int n, int sign)
{
	int i,k;
	double c,d,q,w,s;
	q=6.28318530718/n;
	for(k=0;k<n;k++)
		{
			w=k*q;
			a[k]=b[k]=0.0;
			for(i=0;i<n;i++)
				{
					d=i*w;
					c=cos(d);
					s=sin(d)*sign;
					a[k]+=c*x[i]+s*y[i];
					b[k]+=c*y[i]-s*x[i];
				}
		}
	if(sign==-1)
		{
			c=1.0/n;
			for(k=0;k<n;k++)
				{
					a[k]=c*a[k];
					b[k]=c*b[k];
				}
		}

}
